{    Last change:  RJM  15 Dec 96   10:43 pm    }
unit demo;

{ Demo for the TDatebox component.
  Written by Richard Marks, Hero Software.
  This demo is placed in the public domain}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, datebox, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Panel1: TPanel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Label6: TLabel;
    Panel2: TPanel;
    Label7: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure DateBox1Exit(Sender: TObject);
    procedure SpinEditAnyChange(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ChangeColors(SEnder:Tobject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);



    procedure  Datebox1keypress(Sender:TObject; var Key:Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Datebox:TDatebox;

implementation

{$R *.DFM}





{ In the form OnCreate, we can create a Datebox component and place it
 on the form. This code will work regardless of whether or not the component is installed
 into the Delphi IDE provided that datebox is in the USES clause.
}
procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin

Datebox:=TDatebox.create(self); // Create it
With datebox do begin
    Left := 16 ;   // default parameters
    Top := 16  ;
    Width := 185;
    Height := 105;
    Caption := 'DateBox1' ;
    Font.Color := clWindowText ;
    Font.Height := -11 ;
    Font.Name := 'MS Sans Serif' ;
    Font.Style := [] ;
    ParentFont := False  ;
    TabOrder := 0      ;
    OnExit := DateBox1Exit ;      // Attach an event handler to OnExit
    onkeypress:=DateBox1keypress; // Attach an event handler to OnKeyPress
    parent:=self;
Show;
Refresh;
End;
// Set combobox depending on current value of ShortDateFormat;
For i:=0 to combobox1.items.count-1 do
If uppercase(combobox1.items[i])=uppercase(shortdateformat) then  combobox1.itemindex:=i;
end;

{ In this demo, code has been attached to the OnExit event
 of the Datebox to update the label and SpinBox components on the form.

 The three properties which are read are DateDay,DateMonth and DateYear.

 Note that the dateisvalid property should usually be read first. If a date is not
 valid this will be false, and the three properties dateday,datemonth and dateyear will
 all be set to zero}
procedure TForm1.DateBox1Exit(Sender: TObject);
begin
If not datebox.dateisvalid then with label2 do begin
                                  font.color:=clred;
                                  caption:='Invalid Date in datebox1'
                                  end
                         else    // datebox1.dateisvalid is true
                              with label2 do begin
                                   font.color:=clblack;
                                   caption:='Date is valid in datebox1';
                                   // Turn off Spinedit.onchange otherwise we get recursion!
                                    spinedit1.onchange:=nil;
                                    spinedit2.onchange:=nil;
                                    spinedit3.onchange:=nil;
                                  // Now read the values from the Datebox1 component.
                                  // Note that the values are already parsed by the component
                                  // into a day,month and year value, which depends on the
                                  // settings of Shortdateformat.
                                   spinedit1.value:=datebox.dateday;
                                   spinedit2.value:=datebox.datemonth;
                                   spinedit3.value:=datebox.dateyear;
                                   application.processmessages;
                                   // Finally reassign the spinedit.onchange
                                   spinedit1.onchange:=spineditanychange;
                                   spinedit2.onchange:=spineditanychange;
                                   spinedit3.onchange:=spineditanychange;


                                   end;



end;


{ The onkeypress event can be used to detect whether any key
   has been pressed, but in this demo it is used to detect the
   ENTER key - if the enter key is pressed then tab to the next control}
procedure TForm1.Datebox1keypress(Sender:TObject; var Key:Char);
begin
if key=#13 then begin
key:=#0;
PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
end;
end;




  { You can write to the datebox properties dateday,datemonth and dateyear.
  If the resultant date is valid, the display within the date box will be updated.
  In this demo, the Spinedit controls are used to directly write to the Datebox.}

procedure TForm1.SpinEditAnyChange(Sender: TObject);
begin
With datebox do begin
                 dateday:=spinedit1.value;
                 datemonth:=spinedit2.value;
                 dateyear:=spinedit3.value;
end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
shortdateformat:=combobox1.items[combobox1.itemindex];
datebox.setfocus;
end;

procedure TForm1.ChangeColors(Sender:TObject);
begin

If sender=Button1 then colordialog1.color:=datebox.color
                  else  if sender=button2 then colordialog1.color:=datebox.colorEdit
                        else colordialog1.color:=datebox.colorlabel;
If colordialog1.execute then
   If sender=button1 then            datebox.color:=colordialog1.color
   else if sender=button2 then       datebox.coloredit:=colordialog1.color
   else                              datebox.colorlabel:=colordialog1.color;
   end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
datebox.free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
datebox.setfocus;
end;

end.
